﻿using EPiServer.DynamicContent;
using EPiServer.Core;
using EPiServer.PlugIn;
using EPiServer;
using System;
 
[GuiPlugIn(DisplayName = "GoogleSearch", Description = "Google Custom Search Plug-In", Area = PlugInArea.DynamicContent, Url = "/Templates/DynamicContent/GoogleSearchEdit.ascx")]
public partial class GoogleSearch : IDynamicContent
{
    public string SiteName { get; set; }

    #region IDynamicContent Members

    public System.Web.UI.Control GetControl(PageBase hostPage)
    {
        GoogleSearchContent search =
            hostPage.LoadControl("/Templates/DynamicContent/GoogleSearchContent.ascx") as GoogleSearchContent;
        search.SiteName = SiteName;
        search.DataBind();
        return search;
    }

    public PropertyDataCollection Properties    {
        get { throw new NotImplementedException(); }
    }

    public string Render(EPiServer.PageBase hostPage)
    {
        throw new NotImplementedException();
    }

    public bool RendersWithControl
    {
        get { return true; }
    }

    public string State
    {
        get
        {
            return SiteName;
        }
        set
        {
            if (!String.IsNullOrEmpty(value))
            {
                SiteName = value;
            }
            else
            {
                SiteName = "www.episerver.com";
            }
        }
    }

    #endregion
}