﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Text.RegularExpressions;

namespace EPiServer.DynamicContent
{
    public partial class GoogleSearchContent : System.Web.UI.UserControl
    {
        public string SiteName { get; set; }

        protected void Page_Load(object sender, EventArgs e)
        {
            yourSiteItem.Text = SiteName;
             
            if (!IsPostBack)
            {
                String query = Request.QueryString["q"];
                String site = Request.QueryString["sitesearch"];
                if (!String.IsNullOrEmpty(query))
                    q.Text = ValidateString(HttpUtility.UrlDecode(query.Trim()));                

                if (!String.IsNullOrEmpty(site))                
                    yourSiteItem.Selected = true;
            }
        }

        protected void _btnSearch_Click(Object sender, EventArgs e)
        {
            string site = "";
            if (siteSearch.SelectedValue != "0")
                site = SiteName;
            Response.Redirect(
                String.Format(Request.Url.AbsolutePath +
                    "?q={0}&cx={1}&cof={2}&sitesearch={3}&id={4}&epslanguage={5}",
                    HttpUtility.UrlEncode(ValidateString(q.Text.Trim())),
                    HttpUtility.UrlEncode(cx.Value),
                    HttpUtility.UrlEncode(cof.Value),
                    HttpUtility.UrlEncode(site)
                    , Request.QueryString["id"], Request.QueryString["epslanguage"]
                    ),
                false
                );

            Context.ApplicationInstance.CompleteRequest();
        }

        private String ValidateString(String text)
        {
            if (String.IsNullOrEmpty(text))
                return String.Empty;

            String dangerousStr = "<(?>\"[^\"]*\"|'[^']*'|[^'\">])*>";
            Regex r = new Regex(dangerousStr);
            String output = r.Replace(text, String.Empty);
            return output;
        }

         
    }
}